/*
 * Copyright (c) 2006 CACE Technologies, Davis (California)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 3. Neither the name CACE Technologies nor the names of its contributors 
 * may be used to endorse or promote products derived from this software 
 * without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#if !defined(AFX_AIRPCAPCONFDLG_H__558DD8B9_9213_4A2A_A201_9E743207F820__INCLUDED_)
#define AFX_AIRPCAPCONFDLG_H__558DD8B9_9213_4A2A_A201_9E743207F820__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define FAL_SUCCESS 1
#define FAL_NO_ADAPTERS 2
#define FAL_ERROR 3

/////////////////////////////////////////////////////////////////////////////
// CAirpcapConfDlg dialog

typedef struct _AdapterIdentifier
{
	CString Name;
	CString Description;
	UINT OriginalChannel;
}AdapterIdentifier, *pAdapterIdentifier;

class CAirpcapConfDlg : public CDialog
{
// Construction
public:
	CAirpcapConfDlg(CWnd* pParent = NULL);	// standard constructor
	~CAirpcapConfDlg();

// Dialog Data
	//{{AFX_DATA(CAirpcapConfDlg)
	enum { IDD = IDD_AIRPCAPCONF_DIALOG };
	CButton	m_CheckWepEnabled;
	CComboBox	m_ComboFramesToAccpet;
	CButton	m_ButtonLedBlinking;
	CListCtrl	m_ListKeys;
	CButton	m_CheckFcs;
	CComboBox	m_ComboLinkLayer;
	CComboBox	m_ComboChannel;
	CComboBox	m_InterfacesCombo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAirpcapConfDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAirpcapConfDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnChangeInterface();
	afx_msg void OnApply();
	afx_msg void OnAddKey();
	afx_msg void OnRemoveKey();
	afx_msg void OnEditKey();
	afx_msg void OnMoveKeyUp();
	afx_msg void OnMoveKeyDown();
	afx_msg void OnBlinkLed();
	afx_msg void OnOk();
	afx_msg void OnReset();
	afx_msg void OnHelp();
	virtual void OnCancel();
	afx_msg void OnChangeChannel();
	afx_msg void OnChangeLinkLayer();
	afx_msg void OnChangeCrcInclusion();
	afx_msg void OnChangeCrcCalculation();
	afx_msg void OnDropdownComboInterfaces();
	afx_msg void OnSelchangeComboFramestoaccept();
	afx_msg void OnChangeWepOperation();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	UINT FillAdapterList();
	BOOL FillAdapterDetails(CString AdName);
	BOOL WriteDownAdapterDetails(CString AdName);
	BOOL PopulateKeysListControl();
	static UINT BlinkFunctionStatic(LPVOID pParam);
	void NeedToSave();

	CString m_LastErr;		// Last Error
	INT m_AdNumber;
	AdapterIdentifier* m_AdaptersList;
	UINT m_nAdapters;
	CArray<CString, CString&> m_KeysArray;
	BOOL m_IsLedBlinking;
	CWinThread* m_BlinkThread;
	BOOLEAN m_NeedToSave;
	ULONG m_BufSize;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AIRPCAPCONFDLG_H__558DD8B9_9213_4A2A_A201_9E743207F820__INCLUDED_)
